<?php
/**
 * CreditCard API Demo - logic file
 * version 1.0
 * 
 * author: Thorsten Kugler 
 * email: tkugler@micropayment.de
 * supported 2009 by micropayment
 */

	require_once( 'config.php' );
	require_once( 'tools.php' );
	require_once( './lib/init.php' );
	require_once( './lib/services/' . MCC__CREDITCARDSERVICE_INTERFACE . '.php' );
	require_once( MCP__SERVICELIB_DISPATCHER . 'TNvpServiceDispatcher.php');    


	//get POST/GET vars
	if (getPostVar('action') != "") {$action = getPostVar('action');}
	elseif (getGetVar('action') != "") {$action = getGetVar('action');};


//----------------------------address
	if ($action == 'address') {
	
		session_name('creditcard');
		session_start();
	
		$customerData = array();
		$addressData = array();
		
		try{
    		$customerData = $dispatcher -> customerGet(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId']);
    		$addressData = $dispatcher -> addressGet(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId']);
    		$error_msg = "";
		}
		catch (Exception $e) {
			$error_msg = $e -> getMessage();
		}		
		
		getTemplate('page.address.html', 'error_msg', $error_msg, 'firstname', $customerData['firstname'], 'surname', $customerData['surname'], 'email', $customerData['email'], 'address', $addressData['address'], 'zipcode', $addressData['zipcode'], 'town', $addressData['town'], 'country', $addressData['country'], $_SESSION['customerId'], $tmp);     
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'addressSet') {
		
		session_name('creditcard');
		session_start();
	
		$addressData = 0;
		$customerSet = 0;
		
		try {
			$addressData = $dispatcher -> addressSet(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId'], getPostVar('address'), getPostVar('zipcode'), getPostVar('town'), getPostVar('country'));
			$customerSet = $dispatcher -> customerSet(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId'], null, getPostVar('firstname'), getPostVar('surname'), getPostVar('email'), null);
			$error_msg = 'Daten wurden erfolgreich gespeichert!&nbsp;&nbsp;&nbsp;';
		} 
		catch ( Exception $e ){
			$error_msg = 'Daten nicht gespeichert:<br>'. $e->getMessage();		
		}

		getTemplate('page.status.html', 'msg_class', 'statusSuccess', 'result_status', $error_msg); 
		exit(0);
	}
//---------------------------------------------------------------------

//----------------------------guest status
	if ($action == 'login_guest') {	
		
		session_name('creditcard');
		session_start();
		
		//vars for login page navigation
		$_SESSION['radio'] = 'radio3'; $_SESSION['customer_type'] = 'guest';	
			
		//no products
		if (!$_SESSION['products']) {
			getTemplate('page.login.html', 'radio', $_SESSION['radio'], 'customer_type', $_SESSION['customer_type'], 'error_msg', 'Sie haben keine Produkte ausgew&auml;hlt. <br />Als Gast-Besteller m&uuml;ssen Produkte vorhanden sein.<br /><a href="creditcard_demo.php">Hier gelangen Sie zu unserem Shop</a>', 'status', 'statusError'); exit(0);
		}
		
		//save form data
		if (getPostVar('status') == "saveData") {

			try {
				$customerId = $dispatcher -> customerCreate(MCC__ACCESSKEY, MCC__TESTMODE, null, null, getPostVar('firstname'), getPostVar('surname'), getPostVar('email'));
				$addressData = $dispatcher -> addressSet(MCC__ACCESSKEY, MCC__TESTMODE, $customerId, getPostVar('address'), getPostVar('zipcode'), getPostVar('town'), getPostVar('country'));
				//$creditcardData = $dispatcher -> creditcardDataSet(MCC__ACCESSKEY, MCC__TESTMODE, $customerId, getPostVar('number'), getPostVar('expiryYear'), getPostVar('expiryMonth'));
    			$_SESSION["customerId"] = $customerId;

				print '<SCRIPT language="JavaScript">window.location="./creditcard_demo.php?action=index&direct_login=1&&ccData=empty";</SCRIPT>';
    			exit(0);
			}
			catch(Exception $e) {
				getTemplate('page.guest.html', 'firstname', getPostVar('firstname'), 'surname', getPostVar('surname'), 'email', getPostVar('email'), 'address', getPostVar('address'), 'zipcode', getPostVar('zipcode'), 'town', getPostVar('town'),  'country', getPostVar('country'), 'number', '', 'expiryMonth', "<option>".getPostVar('expiryMonth')."</option>". getMonthCombo(), 'expiryYear', "<option>".getPostVar('expiryYear')."</option>". getYearCombo(), 'status', 'statusError', 'error_msg', $e->getMessage()); 
				exit(0);
			}
		}
		
		getTemplate('page.guest.html', 'firstname', '', 'surname', '', 'email', '', 'address', '', 'zipcode', '', 'town', '',  'country', '', 'number', '', 'expiryMonth', getMonthCombo(), 'expiryYear', getYearCombo(), 'cvc', '', 'error_msg', ''); 
		exit(0);
	}	
		
//----------------------------show index page after login page
	if ($action == 'index') {
		
		session_name('creditcard');
   		session_start();
   		
   		//vars for login page navigation
		$_SESSION['radio'] = 'radio'; $_SESSION['customer_type'] = 'known';
   		
    	//login, from login form
   		if (getPostVar('login_user') != "") {
				
				try {
					$customerData = array();
					$customerData = $dispatcher -> customerGet(MCC__ACCESSKEY, MCC__TESTMODE, getPostVar('username'));	
   		 			
   		 			if (!isset($_SESSION['customerId'])) {
   		 				
   		 				//check password with password in freeParams
	 					if ($customerData['freeParams']['password'] != getPostVar('password')) {
	 						getTemplate('page.login.html', 'error_msg', 'Passwort ist ung&uuml;ltig!', 'status', 'statusError', 'username', getPostVar('username'), 'products', getPostVar('products'), 'radio', $_SESSION['radio'], 'customer_type', $_SESSION['customer_type']);   
    						exit();
	   		 			}
   		 			}
					
   		 			//customer logged in, save to SESSION
   		 			$_SESSION['customerId'] = getPostVar('username');
   		 			
   					$creditcardData = array();
					$creditcardData = $dispatcher -> creditcardDataGet(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId']);
					
    				getTemplate('page.index.html', 'disabledNewCcData', 'disabled', 'firstname', $customerData['firstname'], 'surname', $customerData['surname'], 'email', $customerData['email'], 'number', $creditcardData['number'], 'disabled', 'disabled', 'expiryMonth', "<option>". $creditcardData['expiryMonth']. "</option>". getMonthCombo(), 'expiryYear', "<option>". $creditcardData['expiryYear']. "</option>". getYearCombo(), 'cvc', '');   
 					exit(0);
				}

				catch(Exception $e) {
    				getTemplate('page.login.html', 'error_msg', $e -> getMessage(), 'status', 'statusError', 'username', getPostVar('username'), 'products', getPostVar('products'), 'visibleDIV', "setTimeout(\"document.getElementById('error_msg').style.visibility='visible'\", 1);", 'radio', $_SESSION['radio'], 'customer_type', $_SESSION['customer_type']);     
					exit(0);
    			}
		
   		}
   		//if logged in yet
   		elseif (isset($_GET['direct_login'])) {
			try {
				$creditcardData = array();
   				$creditcardData = $dispatcher -> creditcardDataGet(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId']);
			}
			catch (Exception $e) {
				//do nothing, if data not available, user has to insert it first
			}
   			
   			try {
   				$customerData = array();
   				$customerData = $dispatcher -> customerGet(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId']);
   				
       			//after successfull register creditcard data is empty, user has to put in data
       			if (!isset($_GET['ccData'])) {
       				$disabledButton = "";
       				$disabledFields = "disabled";
       				$disabledNewCcData = "disabled";
       			}
       			else {
       				$disabledButton = "disabled";
       				$disabledFields = "";
       				$disabledNewCcData = "";
       			}
       			
       			getTemplate('page.index.html', 'firstname', $customerData['firstname'], 'surname', $customerData['surname'], 'email', $customerData['email'], 'number', $creditcardData['number'], 'expiryMonth', "<option>". $creditcardData['expiryMonth']. "</option>". getMonthCombo(), 'expiryYear', "<option>". $creditcardData['expiryYear']. "</option>". getYearCombo(), 'cvc', '', 'result_creditcardDataSet', '', 'disabledButton', $disabledButton, 'disabled', $disabledFields, 'disabledNewCcData', $disabledNewCcData); 
				exit(0);
  			}
   			catch (Exception $e) {
   				getTemplate('page.login.html', 'loginError', $e -> getMessage(), 'status', 'statusError', 'username', getPostVar('username'), 'products', getPostVar('products'), 'radio', $_SESSION['radio'], 'customer_type', $_SESSION['customer_type']);     
    			exit(0);
   			}
   		}
	}
//---------------------------------------------------------------------

//----------------------------register new user
	if ($action == 'register') {
		
		session_name('creditcard');
   	 	session_start();

   	 	$_SESSION['username'] = getPostVar('username');
   	 	$_SESSION['firstname'] = getPostVar('firstname');
   	 	$_SESSION['surname'] = getPostVar('surname');
   	 	$_SESSION['address'] = getPostVar('address');
   	 	$_SESSION['email'] = getPostVar('email');
   	 	$_SESSION['zipcode'] = getPostVar('zipcode');
   	 	$_SESSION['town'] = getPostVar('town');
   	 	
   	 	//vars for login page navigation
		$_SESSION['radio'] = 'radio2'; $_SESSION['customer_type'] = 'new';
		
		//password check successfull?
		if ((getPostVar('password') == getPostVar('password2')) && (getPostVar('password') != "") && (strlen(getPostVar('password')) >= MIN_PASSWD_LENGTH)) {
			
			//set password in freeParams	
			$freeParams = array(
					'password' => getPostVar('password')
			);
		
			//create new customer
			try {
				$customerId = $dispatcher -> customerCreate(MCC__ACCESSKEY, MCC__TESTMODE, getPostVar('username'), $freeParams, getPostVar('firstname'), getPostVar('surname'), getPostVar('email'));
				$addressData = $dispatcher -> addressSet(MCC__ACCESSKEY, MCC__TESTMODE, $customerId, getPostVar('address'), getPostVar('zipcode'), getPostVar('town'), getPostVar('country'));
    			$_SESSION['customerId'] = getPostVar('username');
    			
				print '<SCRIPT language="JavaScript">window.location="./creditcard_demo.php?action=index&direct_login=1&ccData=empty";</SCRIPT>';
    			exit(0);
	    	}
	    	catch ( Exception $e ) {
	    		getTemplate('page.login.html', 'error_msg', $e -> getMessage(), 'status', 'statusError', 'products', getPostVar('products'), 'username', getPostVar('username'), 'firstname', getPostVar('firstname'), 'surname', getPostVar('surname'), 'email', getPostVar('email'), 'address', getPostVar('address'), 'zipcode', getPostVar('zipcode'), 'town', getPostVar('town'), 'counter1', "(0)", 'radio', $_SESSION['radio'], 'customer_type', $_SESSION['customer_type']);         
				exit(0);
	    	}
		} 
		else {
			//password check not okay
			getTemplate('page.login.html', 'username', getPostVar('username'), 'firstname', getPostVar('firstname'), 'surname', getPostVar('surname'), 'email', getPostVar('email'), 'address', getPostVar('address'), 'zipcode', getPostVar('zipcode'), 'town', getPostVar('town'), 'error_msg', 'Passw&ouml;rter stimmen nicht &uuml;berein, sind zu kurz oder ung&uuml;ltig!', 'status', 'statusError', 'radio', $_SESSION['radio'], 'customer_type', $_SESSION['customer_type']);      
    	    exit(0);
		}	
	}
//---------------------------------------------------------------------

//----------------------------
	if ($action == 'login') {
		  
	    session_name('creditcard');
	    session_start();
	    	    
		//set products session array
		if(getPostVar('products')) {
	    	foreach (getPostVar('products') as $product) {
				$_SESSION["products"][$product] += 1;
			}
		}
		//avoid multiple addition after page reload
	    $_POST['products'] = "";	    
		
	    //default navigation setting
	    if ($_SESSION['radio'] == "") {$_SESSION['radio'] = 'radio';};
		if ($_SESSION['customer_type'] == "") {$_SESSION['customer_type'] = 'known';};
	    
	    //logged in yet?
		if ($_SESSION['customerId'] != "") {
			print '<SCRIPT language="JavaScript">window.location="./creditcard_demo.php?action=index&direct_login=1";</SCRIPT>';
			exit(0);
	    }

	    //not logged in yet, show login page
	    getTemplate('page.login.html', 'error_msg', '', 'username', getPostVar('username'), 'radio', $_SESSION['radio'], 'customer_type', $_SESSION['customer_type']);  
        exit(0);
	}
//---------------------------------------------------------------------

//----------------------------show logout page
	if ($action == 'logout') {
		
		session_name('creditcard');
		session_start(); 
		
		//delete session data
		$_SESSION = array();
		session_destroy();
		session_unset();
		
		getTemplate('page.logout.html');
        exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'productsbag') {
		
		session_name('creditcard');
		session_start();
	   	
	   	//differ between logged in user and not logged in user
		if ($_SESSION['customerId'] != "") {
    		$template = "page.productsbaglogin.html";
	   	} 
	   	else {
	   		$template = "page.productsbag.html";
	   	}
	   	
    	//calc and set amount
		$_SESSION['amount'] = 0;
		if ($_SESSION['products']) {
			foreach  ($_SESSION['products'] as $product => $count) {
				$_SESSION['amount'] +=  ($aProductList[$product]['amount'] * $count);
			}
		}
		
		//set rows per product
		$sContent = "<br /><table width='100%'>";
		$sContent .= '<form method="POST" action="./creditcard_demo.php">'; 

		//show all products in SESSION
		if ($_SESSION['products']) {
			foreach ($_SESSION['products'] as $product => $count) {
				$sContent .= '<tr>';
				$sContent .= 	'<td width="60" class="productsbought">';
				$sContent .= 		'<img src="./img/'.$product.'.jpg" height="30">';
				$sContent .=	'</td>';
				$sContent .= 	'<td width="150" class="productsbought">'; 
	   			$sContent .= 		$aProductList[$product]['title'].'<br />';
   				$sContent .= 	'</td>';
				$sContent .= 	'<td  width="100" class="productsbought">'; 
   				$sContent .= 		formatAmount(($aProductList[$product]['amount'] / 100)). ' '. PROJECT_CURRENCY;
	    		$sContent .= 	'</td>';    
   				$sContent .= 	'<td  width="100" class="productsbought">'; 
   				$sContent .= 		'<input align="absmiddle" style="font-size:9px;width:30px; height:10px;" type="text" name="count[]" id="count[]" value="'.$count.'">' . ' St&uuml;ck';
   				$sContent .= 	'</td>'; 
				$sContent .= 	'<td  width="250" class="productsbought">';
				$sContent .= 		'<input type="hidden" name="action" id="action" value="reCalc">'; 
				$sContent .= 		'<input type="hidden" name="product[]" id="product[]" value="'.$product.'">';
   				$sContent .= 	"</td>";    
   				$sContent .= "</tr>";
			}
		}
   		$sContent .= "</table><hr><br />";
   			
    	//show amount and recalc button
   		$sContent .= "<table width='100%'>";
   		$sContent .= 	"<tr>";
   		$sContent .= 		'<td width="60">';
   		$sContent .= 			'<input class="reCalc" type="submit" value="Aktualisieren">';
   		$sContent .= 		"</td>";
   		$sContent .= 		'<td width="200"><b>Gesamtsumme</b>:';
   		$sContent .= 		"</td>";
   		$sContent .= 		'<td width="100">'. formatAmount($_SESSION['amount'] / 100). ' '. PROJECT_CURRENCY;
   		$sContent .= 		"</td>";
   		$sContent .= 		'<td width="20">';
   		$sContent .= 		"</td>";
   		$sContent .= 		'<td width="250">';
   		$sContent .= 			'<a href="creditcard_demo.php?action=login"><img src="./img/www.micropayment.de.png" border="0"></a>';
   		$sContent .= 		"</td>";
   		$sContent .= 	"</tr>";
   		$sContent .= "</table>";
   			
		
	    //no products available
   		if ((count($_SESSION['products']) == 0) && ($_SESSION['amount'] == 0)) {
			$sContent = "<br /><em>Keine Produkte vorhanden</em>";
		}   		
   		
		getTemplate($template, 'amount', formatAmount($_SESSION['amount'] / 100), 'productsbought', $sContent, 'error_msg', getGetVar('error_msg'), 'status', getGetVar('status'));  
		exit(0);
	}		
//---------------------------------------------------------------------	
	
//---------------------------------------------------------------------
	if ($action == 'reCalc') {
		
		session_name('creditcard');
		session_start();
		
		$_SESSION['amount'] = 0;
		$aCount = getPostVar('count'); //array reached from form
		$aProducts = getPostVar('product'); //array reached from form

		$c = 0;
		foreach ($aProducts as $product) {
			//check if $count is (number && <= 0)
			if (($aCount[$c] >= 0) && (preg_match("/^\d*$/", $aCount[$c]))) {
				$_SESSION['products'][$product] = $aCount[$c];
				foreach  ($_SESSION['products'] as $product => $count) {
					//calculate amount
					$_SESSION['amount'] +=  ($aProductList[$product]['amount'] * $count);
				}
			}
			$c += 1;
		}
		//back to calling page
		header("Location: ".$_SERVER['HTTP_REFERER']);
		exit(0);
	}
//---------------------------------------------------------------------	
	
//----------------------------
	if ($action == 'productsbought') {

		session_name('creditcard');
   		session_start();
	
   		try {
   			//get session list of custumer
   			$sessionData = array();
   			$sessionData = $dispatcher -> sessionList(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId']);
    		
   			//newest data to the top
   			krsort($sessionData);
   			
   			$productsbought = '
   				<br /><br />
   			';
   			
   			//check if session has status SUCCESS -> successful transaction
   			foreach($sessionData as $tmpdata) {
   			
   				$session2Data = $dispatcher -> sessionGet(MCC__ACCESSKEY, MCC__TESTMODE, $tmpdata);
   			
    			if('SUCCESS' == $session2Data['status']) {
					
    				//css-style indicator 
    				$indStorno = "productsbought";
   				    $sTmp = "";
   				
   				    foreach($session2Data['transactionIds'] as $id) {
   						$transactionData = $dispatcher -> transactionGet(MCC__ACCESSKEY, MCC__TESTMODE, $id);
       					$sTmp .= $transactionData['type'].":".$transactionData['status']." at <br />".$transactionData['created']."<br /><br />";
       					
       					if ('REVERSAL' == $transactionData['type']) {
       						//css-style indicator 
       						$indStorno="warenkorb_storno";
        				};
   	    			}
       			
   					$productsbought .= '
   						<form method="POST" action="./creditcard_demo.php">
   						<table width=100% style="border-bottom:1px dotted #AAAAAA;">
   						<input type="hidden" name="sessionId" id="sessionId" value="';
    				$productsbought .= $tmpdata;
   					$productsbought .= '">
   								<input type="hidden" name="action" id="action" value="do_reversal">
   								<input type="hidden" name="direct_reversal" id="direct_reversal" value="1">
								
   								<input type="hidden" name="customerId" id="customerId" value="';
    				$productsbought .= $_SESSION['customerId'];
   					$productsbought .= '">
   								<input type="hidden" name="transactionId" id="transactionId" value="';
   					$productsbought .= $id;
   					$productsbought .= '">
   							<tr>
   								<td  width="120" class="';
    				$productsbought .= $indStorno;
   					$productsbought .= '">';
    					
   					//product names are saved in freeParams
  					if (isset($session2Data['freeParams'])) {
   					foreach ($session2Data['freeParams'] as $prod => $count) {
  							$productsbought .= "<img align=absmiddle height=\"30\" src=\"./img/".$prod.".jpg\"> Anzahl: ".$count."<br />";
  						}
  					}
  					
    				$productsbought .= '
   								</td>
   								<td width="120" class="';
   					$productsbought .= $indStorno;
   					$productsbought .= '">';
   					
   					//get minutes between now and transaction
    				$tmp_date = round ((time() - strtotime($transactionData['created'])) / 60, 0);
   					//show time only when transaction startet in last 120 minutes
   					if ($tmp_date < 120) {  				
   						$productsbought .= "<div id=\"\" class=\"show_minutes\"> vor ".$tmp_date." Minuten</div><br />".$session2Data['title'];
   					}
   					else {
   						$productsbought .= $session2Data['title'];
   					}
   					
    				$productsbought .= '
   								</td>
   									<td width="80" class="';
   					$productsbought .= $indStorno;
   					$productsbought .= '">';
    				$productsbought .= formatAmount(($session2Data['amount']/100)." ".$session2Data['currency']). ' '. PROJECT_CURRENCY;
   					$productsbought .= '
								</td>
   								<td class="';
   					$productsbought .= $indStorno;
   					$productsbought .= '">';
					$productsbought .= $sTmp;
	    			
   				    if ('CAPTURE' == $transactionData['type']) {
						$productsbought .= '<div class="no_storno">'.'Kein Storno m&ouml;glich'.'</div>';
					}
					elseif ('REVERSAL' != $transactionData['type']) {
						$productsbought .= '<input class="storno" type="submit" value="'.'Stornieren'.'"> *';
					}
					
    				$productsbought .= '
    							</td>
    						</tr>';
       			}
    			$productsbought .= "</form>";	
   			}
   			$productsbought .= "</table>";
    	}
   		catch(Exception $e) {
   			$productsbought = "<br /><em>Keine Produkte vorhanden</em><br />";
    	}
				
		getTemplate('page.productsbought.html', 'productsbought', $productsbought);
   		exit(0);
	}
//---------------------------------------------------------------------

//----------------------------reversal
	elseif ($action == 'do_reversal') {
	
		session_name('creditcard');
	   	session_start();
	
		try {
			$reversalData = array();
			$reversalData = $dispatcher -> transactionReversal(MCC__ACCESSKEY, MCC__TESTMODE, getPostVar('sessionId'), getPostVar('transactionId'));
		}
		catch ( Exception $e ) {
			print '<SCRIPT language="JavaScript">alert("'.$e->getMessage().'");</SCRIPT>';
    	}
		
		header("Location: ".$_SERVER['HTTP_REFERER']);
		exit();
	}
//---------------------------------------------------------------------

//----------------------------
	elseif ($action == 'purchase') {
	
		session_name('creditcard');
   		session_start();
	
		//CVC is necessary!
		if (getPostVar('cvc') == "") {
			$err_msg = "'cvc' is missed";
			getTemplate('page.index.html', 'disabledNewCcData', 'disabled', 'disabled', 'disabled', 'result_creditcardDataSetImg', './img/error.gif', 'result_creditcardDataSet', $err_msg, 'visible_msg', 'style="visibility:visible"', 'firstname', getPostVar('firstname'), 'surname', getPostVar('surname'), 'email', getPostVar('email'), 'number', getPostVar('number_'), 'expiryYear', getPostVar('expiryYear_'), 'expiryMonth', getPostVar('expiryMonth_'), 'cvc', ''); 
			exit(0);	
		}
		
		//set error/success messages 
		$result_sessionCreateImg = "";
		$result_sessionCreate = "";
		$msg_class = "";
		
    	try {
    		//only if new creditcard data
    		if (getPostVar('newCcData') != "") {
    			$creditcardData = $dispatcher -> creditcardDataSet(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId'], getPostVar('number'),getPostVar('expiryYear'),getPostVar('expiryMonth'));
    		}
	    	$customerData = $dispatcher -> customerGet(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId']);

    	}
    	catch ( Exception $e ) {
			$result_sessionCreateImg = './img/error.gif';
	   		$result_sessionCreate = $e -> getMessage();
	   		$msg_class = "error_msg";
    	}

		
		//no products???
		if (count($_SESSION['products']) == 0) {
			$err_msg = "Sie haben keine Produkte ausgew&auml;hlt.<br>Um eine Buchung durchzuf&uuml;hren, m&uuml;ssen Sie zumindest ein Produkt aus dem <a href='creditcard_demo.php'>Shop</a> ausgew&aumlhlt haben.";
			getTemplate('page.index.html', 'disabledNewCcData', 'disabled', 'disabled', 'disabled', 'result_creditcardDataSetImg', './img/error.gif', 'result_creditcardDataSet', $err_msg, 'visible_msg', 'style="visibility:visible"', 'firstname', getPostVar('firstname'), 'surname', getPostVar('surname'), 'email', getPostVar('email'), 'number', getPostVar('number_'), 'expiryYear', getPostVar('expiryYear_'), 'expiryMonth', getPostVar('expiryMonth_'), 'cvc', ''); 
			exit(0);	
		} 
		else {
		   	//calculate amount of bought products
    		$c_amount = 0;
    		foreach ($_SESSION['products'] as $product => $count)	{
    			$c_amount += $aProductList[$product]['amount'] * $count;
    		}
		}   	
    	
		//sessionCreate    	
    	try {
    		$sessionCreate = array();
   			$sessionCreate = $dispatcher -> sessionCreate(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId'], null, PROJECT_NAME, null, null, null, $c_amount, PROJECT_CURRENCY, PROJECT_TITLE, PROJECT_TITLE, getenv("REMOTE_ADDR"), $_SESSION['products'], SEND_MAIL);    

   			$result_sessionCreateImg = './img/success.gif';
	   		$result_sessionCreate = 'Session erfolgreich angelegt'. '<br>expires: '.$result_sessionCreate["expire"]. '<br>ID: '. $result_sessionCreate["sessionId"];
	   		$msg_class = "success_msg";
	   		
	    }
	    catch ( Exception $e ) {
	   		$result_sessionCreateImg = './img/error.gif';
	   		$result_sessionCreate = $e -> getMessage();
	   		$msg_class = "error_msg";
    	}

    	//Purchase
		try {
			//do purchase
			$purchaseData = $dispatcher -> transactionPurchase(MCC__ACCESSKEY, MCC__TESTMODE, $sessionCreate['sessionId'], getPostVar('cvc'));
			
			//only for the payment-image (VISA, ...)
			$creditcardData = $dispatcher -> creditcardDataGet(MCC__ACCESSKEY, MCC__TESTMODE, $_SESSION['customerId']);
  			$dataString .= "Auf Ihrer Abrechnung finden Sie<br />die Abbuchung mit der Transaction-ID:<br /><em> ".$purchaseData['transactionId']."</em><br>";
			
			//status SUCCESS?
			if (($purchaseData['sessionStatus'] == 'SUCCESS') && ($purchaseData['transactionStatus'] == 'SUCCESS')) {

	   			$sProducts .= "<br /><br />Wir danken f&uuml;r Ihren Einkauf!<br /> <b>Sie k&ouml;nnen die gekauften Produkte nun herunterladen:</b><br /><br />";
				foreach ($_SESSION['products'] as $prod => $count) {
   					$sProducts .= "<img align=absmiddle height=\"80\" src=\"./img/".$prod.".jpg\"> ";
   				}
				$sProducts .= "<br />";
				
				$dataString = "<b>Ihr Einkauf war erfolgreich! </b><br /><br />". $dataString;
				
				//empty shopping bag
				$_SESSION['products'] = array();
			}
			else {
				$dataString = "<b>Ihr Einkauf war nicht erfolgreich!</b> <br />Bitte &uuml;berpr&uuml;fen Sie Ihre Kreditkarten-Daten, speziell CVC-Code<br /><br />";
			}
			
		}
		catch ( Exception $e ) {
			$dataString = $e -> getMessage();
    	}	

    	getTemplate('page.purchase.html', 'products', $sProducts, 'msg_class', $msg_class, 'result_sessionCreate', $result_sessionCreate, 'result_sessionCreateImg', $result_sessionCreateImg,  'transactionInfo', $dataString, 'cc-img', './img/'.$creditcardData['type'].'.gif', 'cvc', getPostVar('cvc')); 
		exit(0);
	}
//---------------------------------------------------------------------

//---------------------------------------------------------------------
	if ($action == 'resetTest') {
		
		session_name('creditcard');
		session_start();
		
		try {
			$resetData = $dispatcher -> resetTest(MCC__ACCESSKEY, MCC__TESTMODE);

			session_unset();
			session_destroy(); 
			
			$error_msg = 'Test-Umgebung wurde erfolgreich zurckgesetzt!';
		} 
		catch(Exception $e) {
			$error_msg = 'Test-Umgebung konnte nicht zurckgesetzt werden!';
		}
		
		getTemplate('page.login.html', 'customer_type', 'known', 'radio', 'radio', 'status', 'statusError', 'radio', $_SESSION['radio'], 'customer_type', $_SESSION['customer_type'], 'title', TITLE, 'username', '', 'error_msg', $error_msg);
		exit(0);	
	}
//---------------------------------------------------------------------

else {
	//no GET/POST-variables -> link to demo-shop
	header("Location: index.php");
}
//---------------------------------------------------------------------

?>